﻿using System;
using System.Collections.Generic;
using KRE.Replicate.Contracts.Data;

namespace KRE.Replicate.Client
{
    public class DataFactory
    {
        public Foo Foo1 { get; }
        public Foo Foo2 { get; }
        public Foo Foo3 { get; }

        public Bar Bar1 { get; }
        public Bar Bar2 { get; }
        public Bar Bar3 { get; }

        public DataFactory()
        {
            Bar1 = new Bar
            {
                Id = 1,
                LastModified = DateTime.Now,
                Data = "Origin"
            };

            Bar2 = new Bar
            {
                Id = 1,
                LastModified = DateTime.Now,
                Data = "Primary"
            };

            Bar3 = new Bar
            {
                Id = 1,
                LastModified = DateTime.Now,
                Data = "Secondary"
            };

            Foo1 = new Foo
            {
                Id = 1,
                LastModified = DateTime.Now,
                ListInt = new List<int>(new[] { 0 }),
                DictionaryIntString = new Dictionary<int, string> { { 0, "zero" } },
                Bar = Bar1,
                ListBar = new List<Bar>(new[] { Bar1 })
            };

            Foo2 = new Foo
            {
                Id = 1,
                LastModified = DateTime.Now,
                ListInt = new List<int>(new[] { 0, 1, 2 }),
                DictionaryIntString = new Dictionary<int, string> { { 0, "zero" }, { 1, "primary" } },
                Bar = Bar2,
                ListBar = new List<Bar>(new[] { Bar2 })
            };

            Foo3 = new Foo
            {
                Id = 1,
                LastModified = DateTime.Now,
                ListInt = new List<int>(new[] { 0, 1, 3 }),
                DictionaryIntString = new Dictionary<int, string> { { 0, "zero" }, { 1, "secondary" } },
                Bar = Bar3,
                ListBar = new List<Bar>(new[] { Bar3 })
            };
        }
    }
}
