﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace KRE.Replicate.Contracts.Data
{
    [DataContract]
    public class Foo
    {
        [DataMember]
        public int Id { get; set; }

        [DataMember]
        public DateTime LastModified { get; set; }

        [DataMember]
        public List<int> ListInt { get; set; }

        [DataMember]
        public Dictionary<int, string> DictionaryIntString { get; set; }

        [DataMember]
        public Bar Bar { get; set; }

        [DataMember]
        public List<Bar> ListBar { get; set; }

        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("Foo {").AppendLine();
            sb.Append("\tId: ").Append(Id).AppendLine(";");
            sb.Append("\tLastModified: ").Append(LastModified).AppendLine(";");
            sb.Append("\tListInt: ").Append(string.Join(", ", ListInt)).AppendLine(";");
            sb.Append("\tDictionaryIntString: ").Append(DictAsString()).AppendLine(";");
            sb.Append("\tBar: ").Append(Bar).AppendLine(";");
            sb.Append("\tListBar: ").Append(string.Join(", ", ListBar)).Append("}");
            return sb.ToString();
        }

        private string DictAsString()
        {
            return string.Join(", ", DictionaryIntString.Select(pair => $"{pair.Key} - {pair.Value}"));
        }
    }
}
