﻿using System;
using System.ServiceProcess;
using log4net;
using log4net.Config;

namespace KRE.Replicate.Service
{
    public class Program
    {
        private static readonly ILog Log = LogManager.GetLogger(typeof(Program));

        public static void Main(string[] args)
        {
            XmlConfigurator.Configure();
            try
            {
                if (Environment.UserInteractive)
                {
                    Console.Title = "Replicate Server";
                    var service = new WindowsService();
                    service.StartFake();

                    Console.WriteLine(@"Press Esc to stop");
                    ConsoleKey key;
                    do
                    {
                        key = Console.ReadKey().Key;
                    } while (key != ConsoleKey.Escape);

                    service.StopFake();
                }
                else
                {
                    Log.Info("ServiceBase Run");
                    ServiceBase.Run(new WindowsService());
                }
            }
            catch (Exception ex)
            {
                Log.Error("Main exception: ", ex);
                if (Environment.UserInteractive)
                    Console.ReadKey();
                Environment.Exit(1);
            }
        }
    }
}
